import sys

import pygame
from pygame.locals import *


def prompt(screen, x=0, y=0, width=640):
    font = pygame.font.Font(None, 36)
    return_string = ''

    # calculate the white part of the input area
    height = 32
    input_area = pygame.Rect((x, y), (width, height))

    while 1:
        # fill the input area with white
        screen.fill((255, 255, 255), input_area)

        # put what's currently inputted into the input area
        input_text = font.render(return_string, True, (0, 0, 0))
        screen.blit(input_text, (x, y))
        pygame.display.flip()

        # wait for an event
        event = pygame.event.wait()
        if event.type == QUIT:
            sys.exit()

        if event.type == pygame.KEYDOWN:
            # if escape was hit assume the user doesn't want to enter anything, return nothing
            if event.key == pygame.K_ESCAPE:
                return ''

            # if return was hit, assume the user is finished entering text and return what's been entered
            elif event.key == pygame.K_RETURN:
                return return_string

            # if backspace is hit, move the carat back one space and destroy the last letter
            elif event.key == pygame.K_BACKSPACE:
                # make sure there's something in the string first, don't want to kill what's not there
                if len(return_string) > 0:
                    return_string = return_string[0:len(return_string)-1]
            else:
                # add the typed letter to the string
                return_string = return_string+event.unicode

    return return_string
